Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/callphysiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/callphysiq_mod.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/callphysiq_mod.F	(revision 1724)
@@ -12,5 +12,5 @@
 CONTAINS
 
-SUBROUTINE call_physiq(planet_type, klon,llm,nqtot,                       &
+SUBROUTINE call_physiq(planet_type, klon,llm,nqtot,tname,                 &
                        debut_split,lafin_split,                           &
                        jD_cur,jH_cur_split,zdt_split,                     &
@@ -23,5 +23,6 @@
 
   USE physiq_mod, ONLY: physiq
-  USE module_model_constants, only : p0,rcp
+  USE module_model_constants, only : p0,rcp,cp
+  use moyzon_mod, only: tmoy
   IMPLICIT NONE
 
@@ -31,27 +32,30 @@
   INTEGER,INTENT(IN) :: llm  ! number of atmospheric layers
   INTEGER,INTENT(IN) :: nqtot ! number of tracers
+  CHARACTER(len=*),INTENT(IN) :: tname(nqtot) ! tracer names
   LOGICAL,INTENT(IN) :: debut_split ! .true. if very first call to physics
   LOGICAL,INTENT(IN) :: lafin_split ! .true. if last call to physics
-  REAL*4,INTENT(IN) :: JD_cur ! Julian day
-  REAL*4,INTENT(IN) :: JH_cur_split ! Julian hour (fraction of day)
-  REAL*4,INTENT(IN) :: zdt_split ! time step over which the physics are evaluated
-  REAL*4,INTENT(IN) :: zplev_omp(klon,llm+1) ! interlayer pressure (Pa)
-  REAL*4,INTENT(IN) :: zplay_omp(klon,llm) ! mid-layer pressure (Pa)
-  REAL*4,INTENT(INOUT) :: zpk_omp(klon,llm)
-  REAL*4,INTENT(IN) :: zphi_omp(klon,llm) ! geopotential at midlayer
-  REAL*4,INTENT(INOUT) :: zphis_omp(klon) ! surface geopotential
-  REAL*4,INTENT(INOUT) :: presnivs_omp(llm) ! approximate pressure of atm. layers
-  REAL*4,INTENT(IN) :: zufi_omp(klon,llm) ! zonal wind (m/s)
-  REAL*4,INTENT(IN) :: zvfi_omp(klon,llm) ! meridional wind (m/s)
-  REAL*4,INTENT(INOUT) :: zrfi_omp(klon,llm) ! relative wind vorticity, in s-1
-  REAL*4,INTENT(IN) :: ztfi_omp(klon,llm) ! temperature (K)
-  REAL*4,INTENT(IN) :: zqfi_omp(klon,llm,nqtot) ! tracers (*/kg of air)
-  REAL*4,INTENT(IN) :: flxwfi_omp(klon,llm) ! Vertical mass flux on lower mesh interfaces (kg/s) 
+  REAL*8,INTENT(IN) :: JD_cur ! Julian day
+  REAL*8,INTENT(IN) :: JH_cur_split ! Julian hour (fraction of day)
+  REAL*8,INTENT(IN) :: zdt_split ! time step over which the physics are evaluated
+  REAL*8,INTENT(IN) :: zplev_omp(klon,llm+1) ! interlayer pressure (Pa)
+  REAL*8,INTENT(IN) :: zplay_omp(klon,llm) ! mid-layer pressure (Pa)
+  REAL*8,INTENT(INOUT) :: zpk_omp(klon,llm)
+  REAL*8,INTENT(IN) :: zphi_omp(klon,llm) ! geopotential at midlayer
+  REAL*8,INTENT(INOUT) :: zphis_omp(klon) ! surface geopotential
+  REAL*8,INTENT(INOUT) :: presnivs_omp(llm) ! approximate pressure of atm. layers
+  REAL*8,INTENT(IN) :: zufi_omp(klon,llm) ! zonal wind (m/s)
+  REAL*8,INTENT(IN) :: zvfi_omp(klon,llm) ! meridional wind (m/s)
+  REAL*8,INTENT(INOUT) :: zrfi_omp(klon,llm) ! relative wind vorticity, in s-1
+  REAL*8,INTENT(IN) :: ztfi_omp(klon,llm) ! temperature (K)
+  REAL*8,INTENT(IN) :: zqfi_omp(klon,llm,nqtot) ! tracers (*/kg of air)
+  REAL*8,INTENT(IN) :: flxwfi_omp(klon,llm) ! Vertical mass flux on lower mesh interfaces (kg/s) 
   ! tendencies (in */s) from the physics:
-  REAL*4,INTENT(OUT) :: zdufi_omp(klon,llm) ! tendency on zonal winds
-  REAL*4,INTENT(OUT) :: zdvfi_omp(klon,llm) ! tendency on meridional winds
-  REAL*4,INTENT(OUT) :: zdtfi_omp(klon,llm) ! tendency on temperature
-  REAL*4,INTENT(OUT) :: zdqfi_omp(klon,llm,nqtot) ! tendency on tracers
-  REAL*4,INTENT(OUT) :: zdpsrf_omp(klon) ! tendency on surface pressure
+  REAL*8,INTENT(OUT) :: zdufi_omp(klon,llm) ! tendency on zonal winds
+  REAL*8,INTENT(OUT) :: zdvfi_omp(klon,llm) ! tendency on meridional winds
+  REAL*8,INTENT(OUT) :: zdtfi_omp(klon,llm) ! tendency on temperature
+  REAL*8,INTENT(OUT) :: zdqfi_omp(klon,llm,nqtot) ! tendency on tracers
+  REAL*8,INTENT(OUT) :: zdpsrf_omp(klon) ! tendency on surface pressure
+  REAL*8 :: zplevmoy(llm+1) ! planet-averaged mean pressure (Pa) at interfaces
+  REAL*8 :: ztmoy(llm)
 
 !  ! Local variables
@@ -77,8 +81,12 @@
 
 ! Set dummy variables for Mars to zero (additional and prob useless security)
-  zpk_omp=(zplay_omp/p0)**rcp
-  zphis_omp(:)=zphi_omp(1,1)
+! NB: tname already filled with tracers' names (though not used here)
+  zpk_omp(1:klon,1:llm)=cp*((zplay_omp(1:klon,1:llm)/p0)**rcp)
+  !print*,'zpk_omp',zpk_omp(1,:)
+  zphis_omp(1:klon)=zphi_omp(1:klon,1)
   presnivs_omp(:)=0.
   zrfi_omp(:,:)=0.
+  ztmoy(:)=ztfi_omp(1,:)
+  zplevmoy(:)=zplev_omp(1,:)
 ! Call physics package with required inputs/outputs
   CALL physiq(klon,           &
@@ -101,4 +109,6 @@
               zqfi_omp,       &
               flxwfi_omp,     &
+              zplevmoy,       &
+              ztmoy,          &
               zdufi_omp,      &
               zdvfi_omp,      &
@@ -106,5 +116,5 @@
               zdqfi_omp,      &
               zdpsrf_omp)
-
+   deallocate(tmoy)
 END SUBROUTINE call_physiq
 
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/iniphysiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/iniphysiq_mod.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/iniphysiq_mod.F	(revision 1724)
@@ -10,5 +10,5 @@
 !                            dtphys,daysec,day_ini,hour_ini
 use comconst_mod, only : cpp
-use cpdet_mod, only: cpdet,ini_cpdet
+use cpdet_phy_mod, only: init_cpdet_phy
 USE control_mod, ONLY: planet_type
 !use surfdat_h, only: ini_surfdat_h
@@ -18,5 +18,5 @@
 use dimphy, only: init_dimphy
 USE phys_state_var_mod
-
+use module_model_constants, only : nu, TT00
 implicit none
 
@@ -27,5 +27,5 @@
 REAL,intent(in) :: punjours
 !DOUBLE PRECISION,intent(in) :: ptimestep
-REAL,intent(in) :: phour_ini
+REAL*8,intent(in) :: phour_ini
 
 !real,intent(in) :: prad ! radius of the planet (m)
@@ -35,5 +35,5 @@
 !real,intent(in) :: punjours ! length (in s) of a standard day [daysec]
 integer,intent(in) :: pdayref ! reference day of for the simulation [day_ini]
-real*4,intent(in) :: ptimestep !physics time step (s) [dtphys]
+real*8,intent(in) :: ptimestep !physics time step (s) [dtphys]
 integer,intent(in) :: iflag_phys ! type of physics to be called
 
@@ -43,5 +43,5 @@
 !real,intent(in) :: phour_ini   ! start time (fraction of day) of the run 0=<phour_ini<1
 real,intent(in) :: piphysiq   ! call physics every piphysiq dynamical timesteps
-
+real*8 :: CPPP,nuvenus,T0venus
 
 ! copy some fundamental parameters to physics 
@@ -81,5 +81,8 @@
       cpp=pcpp
       planet_type="venus"
-      call ini_cpdet
+      CPPP=pcpp
+      nuvenus=nu
+      T0venus=TT00
+      call init_cpdet_phy(CPPP,nuvenus,T0venus)
 
 !! a few time constants initialization 
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_inputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_inputs_physiq_mod.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_inputs_physiq_mod.F	(revision 1724)
@@ -1,7 +1,3 @@
 MODULE update_inputs_physiq_mod
-
-IMPLICIT NONE
-
-CHARACTER(len=20),save,allocatable,dimension(:) :: traceurs ! tracer names
 
 CONTAINS
@@ -17,4 +13,12 @@
 !SUBROUTINE update_inputs_physiq_slope
 
+!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+
+!c  Returns solar longitude, Ls (in deg.), from day number (in sol),
+!c  where sol=0=Ls=0 at the northern hemisphere spring equinox
+
+
+!!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -31,16 +35,25 @@
   REAL, INTENT(IN) :: GMT,elaps,lon_input,ls_input,lct_input
   REAL,INTENT(OUT) :: MY
-  REAL,INTENT(OUT) :: ptime,pday
+  REAL*8,INTENT(OUT) :: ptime,pday
 
     !
     ! specified
     !
-    ptime = (GMT + elaps/3700.) !! universal time (0<ptime<1): ptime=0.5 at 12:00 UT 
+  IF (JULYR .ne. 9999) THEN
+    ptime = (GMT + elaps/420000.) !! universal time (0<ptime<1): ptime=0.5 at 12:00 UT 
     ptime = MODULO(ptime,24.)   !! the two arguments of MODULO must be of the same type 
     ptime = ptime / 24.
-    pday = (JULDAY - 1 + INT((3700*GMT+elaps)/88800))
+    pday = (JULDAY - 1 + INT((420000.0*GMT+elaps)/1.008e7))
+    pday = MODULO(int(pday),2)
+    MY = (JULYR-2000) + (1.008e7*(JULDAY - 1)+420000.0*GMT+elaps)/2.016e7
+    MY = INT(MY)
+  ELSE
+    ptime = lct_input - lon_input / 15. + elaps/(4200.)
+    ptime = MODULO(ptime,2808.)
+    ptime = ptime / 2808.
+    print*,'ptime',ptime
     pday = MODULO(int(pday),669)
-    MY = (JULYR-2000) + (88800.*(JULDAY - 1)+3700.*GMT+elaps)/59496000.
-    MY = INT(MY)
+    MY = 2024
+ ENDIF
 
 END SUBROUTINE update_inputs_physiq_time
@@ -48,5 +61,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-SUBROUTINE update_inputs_physiq_tracers(nq,MARS_MODE)
+SUBROUTINE update_inputs_physiq_tracers(nq,MARS_MODE,tname)
 
   !use infotrac
@@ -54,7 +67,7 @@
   implicit none
   INTEGER, INTENT(IN) :: nq,MARS_MODE
-
-  ALLOCATE(traceurs(nq))
-  traceurs(:)='zolbxs' 
+  CHARACTER(len=*), INTENT(INOUT) :: tname(nq) ! tracer names
+
+  tname(:)='zolbxs' 
   !call infotrac_init ! Need traceur.def
 
@@ -93,5 +106,5 @@
             ips,ipe,jps,jpe,&
             JULYR,ngrid,nlayer,&
-            DX,DY,MSFT,&
+            DDX,DDY,MSFT,&
             lat_input, lon_input,&
             XLAT,XLONG)
@@ -105,5 +118,5 @@
    USE geometry_mod, ONLY: latitude,latitude_deg,&
                            longitude,longitude_deg,&
-                           cell_area
+                           cell_area,dx,dy
 
    implicit none
@@ -113,5 +126,5 @@
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(IN)  :: &
      MSFT,XLAT,XLONG
-   REAL, INTENT(IN) :: dx,dy
+   REAL, INTENT(IN) :: ddx,ddy
    REAL, INTENT(IN) :: lat_input, lon_input
    INTEGER :: i,j,subs
@@ -130,5 +143,5 @@
     !----------------------------------------!
     !parea(subs) = dx*dy                           !! 1. idealized cases - computational grid
-    parea(subs) = (dx/msft(i,j))*(dy/msft(i,j))    !! 2. WRF map scale factors - assume that msfx=msfy (msf=covariance)
+    parea(subs) = (ddx/msft(i,j))*(ddy/msft(i,j))    !! 2. WRF map scale factors - assume that msfx=msfy (msf=covariance)
     !parea(subs)=dx*dy/msfu(i,j)                   !! 3. special for Mercator GCM-like simulations
 
@@ -167,4 +180,6 @@
    IF(.not.ALLOCATED(latitude_deg)) ALLOCATE(latitude_deg(ngrid))
    IF(.not.ALLOCATED(cell_area)) ALLOCATE(cell_area(ngrid))
+   IF (.not.ALLOCATED(dx)) ALLOCATE(dx(ngrid))
+   IF (.not.ALLOCATED(dy)) ALLOCATE(dy(ngrid))
    longitude(:) = plon(:)
    latitude(:) = plat(:)
@@ -184,5 +199,5 @@
             M_ALBEDO,CST_AL,&
             M_TSURF,M_EMISS,M_CO2ICE,&
-            M_GW,M_Z0,CST_Z0,&
+            M_GW,M_Z0,&
             M_H2OICE,&
             phisfi_val)
@@ -195,5 +210,5 @@
    INTEGER, INTENT(IN) :: ips,ipe,jps,jpe,JULYR,MARS_MODE
    INTEGER :: i,j,subs,nlast
-   REAL, INTENT(IN  ) :: CST_AL, phisfi_val, CST_Z0
+   REAL, INTENT(IN  ) :: CST_AL, phisfi_val
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(IN)  :: &
      M_ALBEDO,M_TSURF,M_EMISS,M_CO2ICE,M_H2OICE,M_Z0
@@ -334,5 +349,5 @@
             M_Q2,M_WSTAR)
 
-   !use turb_mod, only: q2,wstar,turb_resolved
+   use turb_mod, only: q2,wstar,turb_resolved
 
    implicit none
@@ -340,10 +355,38 @@
    INTEGER, INTENT(IN) :: ims,ime,jms,jme,kms,kme
    INTEGER, INTENT(IN) :: ips,ipe,jps,jpe
-   INTEGER :: i,j,subs,nlast      
+   INTEGER :: i,j,subs,nlast
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(IN)  :: M_WSTAR
    REAL, DIMENSION( ims:ime, kms:kme+1, jms:jme ), INTENT(IN) :: M_Q2
    LOGICAL, INTENT(IN ) :: RESTART,isles
 
-   !! Nothing is done
+   turb_resolved =.true.
+   print*,'turb_resolved :',isles
+
+   DO j = jps,jpe
+   DO i = ips,ipe
+
+     !-----------------------------------!
+     ! 1D subscript for physics "cursor" !
+     !-----------------------------------!
+     subs = (j-jps)*(ipe-ips+1)+(i-ips+1)
+
+     !PBL wind variance
+     IF (.not. restart) THEN
+      q2(subs,:) = 1.E-6
+      wstar(subs)=0.
+     ELSE
+      q2(subs,:)=M_Q2(i,:,j)
+      wstar(subs)=M_WSTAR(i,j)
+     ENDIF
+
+   ENDDO
+   ENDDO
+
+   !!---------------------!!
+   !! OUTPUT FOR CHECKING !!
+   !!---------------------!!
+   nlast = (ipe-ips+1)*(jpe-jps+1)
+   print*,"check: q2",q2(1,1),q2(nlast,kme+1)
+   print*,"check: wstar",wstar(1),wstar(nlast)
 
 END SUBROUTINE update_inputs_physiq_turb
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F	(revision 1724)
@@ -118,9 +118,9 @@
 SUBROUTINE update_outputs_physiq_turb( &
             ims,ime,jms,jme,kms,kme,&
-            ips,ipe,jps,jpe,&
+            ips,ipe,jps,jpe,kps,kpe,&
             M_Q2,M_WSTAR,&
             HFMAX,ZMAX,USTM,HFX)
 
-   !use turb_mod, only: q2,wstar,ustar,sensibFlux,&
+   use turb_mod, only: q2,wstar,yustar,sens!,&
    !                     hfmax_th,zmax_th
 
@@ -128,10 +128,32 @@
 
    INTEGER, INTENT(IN) :: ims,ime,jms,jme,kms,kme
-   INTEGER, INTENT(IN) :: ips,ipe,jps,jpe
-   INTEGER :: i,j,subs    
+   INTEGER, INTENT(IN) :: ips,ipe,jps,jpe,kps,kpe
+   INTEGER :: i,j,subs
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(INOUT)  :: &
      M_WSTAR,HFMAX,ZMAX,USTM,HFX
    REAL, DIMENSION( ims:ime, kms:kme+1, jms:jme ), INTENT(INOUT) :: M_Q2
 
+   DO j = jps,jpe
+   DO i = ips,ipe
+
+     !-----------------------------------!
+     ! 1D subscript for physics "cursor" !
+     !-----------------------------------!
+     subs = (j-jps)*(ipe-ips+1)+(i-ips+1)
+
+     !-------------------------------------------------------!
+     ! Save key variables for restart and output and nesting !  
+     !-------------------------------------------------------!
+     M_Q2(i,kps:kpe+1,j) = q2(subs,:)
+     M_WSTAR(i,j) = wstar(subs)
+
+     !! output only (arrays already in phys modules)
+     !HFMAX(i,j) = HFMAX_TH(subs)
+     !ZMAX(i,j) = ZMAX_TH(subs)
+     USTM(i,j) = yustar(subs)
+     HFX(i,j) = sens(subs)
+
+  ENDDO
+  ENDDO
 
 END SUBROUTINE update_outputs_physiq_turb
@@ -144,5 +166,5 @@
            SWDOWNZ,TAU_DUST,QSURFDUST,& 
            MTOT,ICETOT,TAU_ICE,& 
-           HR_SW,HR_LW,& 
+           HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,& 
            RDUST,VMR_ICE,RICE) 
 
@@ -155,5 +177,5 @@
      MTOT,ICETOT,TAU_ICE 
   REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: & 
-     HR_SW,HR_LW,RDUST,VMR_ICE,RICE 
+     HR_SW,HR_LW,HR_DYN,RDUST,VMR_ICE,RICE,DT,DTRAD,DTVDF,DTAJS
   INTEGER :: i,j,subs 
  
@@ -171,4 +193,9 @@
    HR_SW(i,kps:kpe,j) = comm_HR_SW(subs,kps:kpe) 
    HR_LW(i,kps:kpe,j) = comm_HR_LW(subs,kps:kpe) 
+   HR_DYN(i,kps:kpe,j) = comm_HR_DYN(subs,kps:kpe)
+   DT(i,kps:kpe,j) = comm_DT(subs,kps:kpe)
+   DTRAD(i,kps:kpe,j) = comm_DT_RAD(subs,kps:kpe)
+   DTVDF(i,kps:kpe,j) = comm_DT_VDF(subs,kps:kpe)
+   DTAJS(i,kps:kpe,j) = comm_DT_AJS(subs,kps:kpe)
 
    ENDDO 
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_void_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_void_lmd_new/update_outputs_physiq_mod.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_void_lmd_new/update_outputs_physiq_mod.F	(revision 1724)
@@ -71,5 +71,5 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,&
+            HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,&
             RDUST,VMR_ICE,RICE)
 
@@ -80,5 +80,5 @@
      MTOT,ICETOT,TAU_ICE
    REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: &
-     HR_SW,HR_LW,RDUST,VMR_ICE,RICE
+     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,HR_DYN,DT,DTRAD,DTVDF,DTAJS
    INTEGER :: i,j,subs
 
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new	(revision 1724)
@@ -40,5 +40,5 @@
         isfflx, diff_opt, km_opt, &
         HISTORY_INTERVAL, &
-        HR_SW,HR_LW,SWDOWNZ,&
+        HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,SWDOWNZ,&
         TAU_DUST,RDUST,QSURFDUST,&
         MTOT,ICETOT,VMR_ICE,TAU_ICE,RICE,&
@@ -109,5 +109,5 @@
 REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(OUT ) :: &
      RTHBLTEN,RUBLTEN,RVBLTEN, &
-     HR_SW,HR_LW,RDUST,VMR_ICE,RICE
+     HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,RDUST,VMR_ICE,RICE
 REAL, DIMENSION( ims:ime, kms:kme+1, jms:jme ), INTENT(INOUT ) :: &
      M_Q2
@@ -138,16 +138,17 @@
    ! ------> inputs:
    INTEGER :: ngrid,nlayer,nq,nsoil 
-   REAL :: pday,ptime,MY  
+   REAL*8 :: pday,ptime
+   REAL :: MY  
    REAL :: phisfi_val
    LOGICAL :: firstcall,lastcall
    ! ----------	
-   REAL,DIMENSION(:,:),ALLOCATABLE :: pplev,pplay,pphi,pu,pv,pt,flxw
-   REAL,DIMENSION(:,:,:),ALLOCATABLE :: pq  
+   REAL*8,DIMENSION(:,:),ALLOCATABLE :: pplev,pplay,pphi,pu,pv,pt,flxw
+   REAL*8,DIMENSION(:,:,:),ALLOCATABLE :: pq  
 
    ! <------ outputs:
    !     physical tendencies
-   REAL,DIMENSION(:),ALLOCATABLE :: pdpsrf
-   REAL,DIMENSION(:,:),ALLOCATABLE :: pdu,pdv,pdt
-   REAL,DIMENSION(:,:,:),ALLOCATABLE :: pdq
+   REAL*8,DIMENSION(:),ALLOCATABLE :: pdpsrf
+   REAL*8,DIMENSION(:,:),ALLOCATABLE :: pdu,pdv,pdt,pdtheta
+   REAL*8,DIMENSION(:,:,:),ALLOCATABLE :: pdq
    ! ... intermediate arrays
    REAL, DIMENSION(:), ALLOCATABLE  :: &
@@ -158,5 +159,6 @@
    ! Additional control variables
    INTEGER :: sponge_top,relax,ips,ipe,jps,jpe,kps,kpe
-   REAL :: elaps, ptimestep
+   REAL :: elaps
+   REAL*8 :: ptimestep
    INTEGER :: test
    REAL :: wappel_phys
@@ -173,5 +175,5 @@
              dp_save
       REAL, DIMENSION(:,:,:), ALLOCATABLE, SAVE :: &
-             du_save, dv_save, dt_save
+             du_save, dv_save, dt_save,dtheta_save
       REAL, DIMENSION(:,:,:,:), ALLOCATABLE, SAVE :: &
              dq_save      
@@ -180,5 +182,5 @@
              dp_save
       REAL, DIMENSION(:,:), ALLOCATABLE, SAVE :: &
-             du_save, dv_save, dt_save
+             du_save, dv_save, dt_save,dtheta_save
       REAL, DIMENSION(:,:,:), ALLOCATABLE, SAVE :: &
              dq_save      
@@ -191,9 +193,10 @@
 
    !! arguments to physiq
-   REAL,ALLOCATABLE :: zpk_omp(:,:)
-   REAL,ALLOCATABLE :: zphis_omp(:) ! surface geopotential
-   REAL,ALLOCATABLE :: presnivs_omp(:) ! approximate pressure of atm. layers  
-   REAL,ALLOCATABLE :: zrfi_omp(:,:) ! relative wind vorticity, in s-1
-
+   CHARACTER(len=20),ALLOCATABLE :: tname(:) ! tracer names
+   REAL*8,ALLOCATABLE :: zpk_omp(:,:)
+   REAL*8,ALLOCATABLE :: zphis_omp(:) ! surface geopotential
+   REAL*8,ALLOCATABLE :: presnivs_omp(:) ! approximate pressure of atm. layers  
+   REAL*8,ALLOCATABLE :: zrfi_omp(:,:) ! relative wind vorticity, in s-1
+   REAL :: tk1,tk2
 !==================================================================
 ! CODE
@@ -301,4 +304,5 @@
    ALLOCATE(dv_save(ngrid,nlayer,max_dom))
    ALLOCATE(dt_save(ngrid,nlayer,max_dom))
+   ALLOCATE(dtheta_save(ngrid,nlayer,max_dom))
    ALLOCATE(dq_save(ngrid,nlayer,nq,max_dom))
    dp_save(:,:)=0.    !! initialize these arrays ...
@@ -306,4 +310,5 @@
    dv_save(:,:,:)=0.
    dt_save(:,:,:)=0.
+   dtheta_save(:,:,:)=0.
    dq_save(:,:,:,:)=0.
 ENDIF
@@ -319,4 +324,5 @@
 ALLOCATE(dv_save(ngrid,nlayer))
 ALLOCATE(dt_save(ngrid,nlayer))
+ALLOCATE(dtheta_save(ngrid,nlayer))
 ALLOCATE(dq_save(ngrid,nlayer,nq))
 ENDIF
@@ -325,4 +331,5 @@
 dv_save(:,:)=0.
 dt_save(:,:)=0.
+dtheta_save(:,:)=0.
 dq_save(:,:,:)=0.
 flag_first_restart=.false.
@@ -369,4 +376,5 @@
 ! ALLOCATE !
 !----------!
+IF (.not.ALLOCATED(tname)) ALLOCATE(tname(nq)) 
 !-------------------------------------------------------------------------------!
 ! outputs:									!	
@@ -381,4 +389,5 @@
 ALLOCATE(pdv(ngrid,nlayer))
 ALLOCATE(pdt(ngrid,nlayer))
+ALLOCATE(pdtheta(ngrid,nlayer))
 ALLOCATE(pdq(ngrid,nlayer,nq))
 !!!
@@ -392,10 +401,13 @@
 pdv(:,:)=dv_save(:,:,id)
 pdt(:,:)=dt_save(:,:,id)
+pdtheta(:,:)=dtheta_save(:,:,id)
 pdq(:,:,:)=dq_save(:,:,:,id)
 #else
+print*,'else'
 pdpsrf(:)=dp_save(:)
 pdu(:,:)=du_save(:,:)
 pdv(:,:)=dv_save(:,:)
 pdt(:,:)=dt_save(:,:)
+pdtheta(:,:)=dtheta_save(:,:)
 pdq(:,:,:)=dq_save(:,:,:)
 #endif
@@ -442,5 +454,5 @@
   !! tracers' name
   PRINT *,'** ',planet_type,'** TRACERS NAMES'
-  CALL update_inputs_physiq_tracers(nq,MARS_MODE)
+  CALL update_inputs_physiq_tracers(nq,MARS_MODE,tname)
   !! PHYSICS VARIABLES (cf. iniphysiq in LMD GCM)
   !! parameters are defined in the module_model_constants.F WRF routine
@@ -504,12 +516,4 @@
   ENDIF
 ENDIF
-
-IF (MARS_MODE .EQ. 32) THEN
-  IF (firstcall .EQV. .true. .and. (.not. restart)) THEN
-      q_prof(:,7) = 0.95
-!! traceurs(7)   = 'co2'
-  ENDIF
-ENDIF
-
 
 IF (firstcall .EQV. .true.) THEN
@@ -621,5 +625,5 @@
             M_ALBEDO,CST_AL,&
             M_TSURF,M_EMISS,M_CO2ICE,&
-            M_GW,M_Z0,CST_Z0,&
+            M_GW,M_Z0,&
             M_H2OICE,&
             phisfi_val)
@@ -653,4 +657,5 @@
 pdv(:,:)=0.
 pdt(:,:)=0.
+pdtheta(:,:)=0.
 pdq(:,:,:)=0.
 print *, '** ',planet_type,'** CALL TO LMD PHYSICS'
@@ -662,5 +667,5 @@
             ptime,pday,MY)
 !!!
-CALL call_physiq(planet_type,ngrid,nlayer,nq,       &
+CALL call_physiq(planet_type,ngrid,nlayer,nq,tname, &
                        firstcall,lastcall,          &
                        pday,ptime,ptimestep,        &
@@ -679,4 +684,17 @@
 ENDIF
 #endif
+
+IF (planet_type .eq. "venus" ) THEN
+  DO j=jps,jpe
+  DO i=ips,ipe
+    do k=kps,kpe
+      subs=(j-jps)*(ipe-ips+1)+(i-ips+1)
+      tk1=(pt(subs,k)**nu + nu*TT00**nu*log((p1000mb/pplay(subs,k))**rcp))**(1/nu)
+      tk2=((pt(subs,k) + pdt(subs,k))**nu + nu*TT00**nu*log((p1000mb/pplay(subs,k))**rcp))**(1/nu)
+      pdtheta(subs,k)=tk2-tk1
+    enddo
+  ENDDO
+  ENDDO
+ENDIF
 
 print *, '** ',planet_type,'** CALL TO LMD PHYSICS DONE'
@@ -694,5 +712,4 @@
 DEALLOCATE(zrfi_omp)
 
-
 !---------------------------------------------------------------------------------!
 ! PHYSIQ TENDENCIES ARE SAVED TO BE SPLIT WITHIN INTERMEDIATE DYNAMICAL TIMESTEPS !
@@ -703,4 +720,5 @@
 dv_save(:,:,id)=pdv(:,:)
 dt_save(:,:,id)=pdt(:,:)
+dtheta_save(:,:,id)=pdtheta(:,:)
 dq_save(:,:,:,id)=pdq(:,:,:)
 #else
@@ -709,4 +727,5 @@
 dv_save(:,:)=pdv(:,:)
 dt_save(:,:)=pdt(:,:)
+dtheta_save(:,:)=pdtheta(:,:)
 dq_save(:,:,:)=pdq(:,:,:)
 #endif
@@ -737,5 +756,5 @@
 CALL update_outputs_physiq_turb( &
             ims,ime,jms,jme,kms,kme,&
-            ips,ipe,jps,jpe,&
+            ips,ipe,jps,jpe,kps,kpe,&
             M_Q2,M_WSTAR,&
             HFMAX,ZMAX,USTM,HFX)
@@ -746,7 +765,10 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,&
+            HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,&
             RDUST,VMR_ICE,RICE)
 !!!
+print*,"update_outputs_physiq_diag"
+
+
 ENDIF call_physics
 
@@ -770,5 +792,6 @@
 ! --is the one calculated during the last call to physics          !
 !------------------------------------------------------------------!
-
+!print*,'pdt',pdt(1,1),pdt(1,nlayer)
+!print*,'exner',exner(1,:,1)
 DO j = jps,jpe
 DO i = ips,ipe
@@ -778,16 +801,16 @@
     ! zonal wind
   RUBLTEN(i,kps:kpe,j) = pdu(subs,kps:kpe) 
-
     ! meridional wind
   RVBLTEN(i,kps:kpe,j) = pdv(subs,kps:kpe) 
-
     ! potential temperature
     ! (dT = dtheta * exner for isobaric coordinates or if pressure variations are negligible)
-  RTHBLTEN(i,kps:kpe,j) = pdt(subs,kps:kpe) / exner(i,kps:kpe,j)
-
+  IF (planet_type .eq. "venus" ) THEN
+    RTHBLTEN(i,kps:kpe,j) = pdtheta(subs,kps:kpe)
+  ELSE
+   RTHBLTEN(i,kps:kpe,j) = pdt(subs,kps:kpe) / exner(i,kps:kpe,j)
+  ENDIF
     ! update surface pressure (cf CO2 cycle in physics)
     ! here dt is needed
   PSFC(i,j)=PSFC(i,j)+pdpsrf(subs)*dt 
-
     ! tracers
   SCALAR(i,kps:kpe,j,1)=0.
@@ -807,5 +830,4 @@
 ENDDO
 ENDDO
-
 DEALLOCATE(pdpsrf)
 DEALLOCATE(pdu)
@@ -813,5 +835,5 @@
 DEALLOCATE(pdt)
 DEALLOCATE(pdq)
-
+DEALLOCATE(pdtheta)
 !!*****!!
 !! END !!
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/Makefile
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/Makefile	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/Makefile	(revision 1724)
@@ -17,5 +17,6 @@
 	module_optional_si_input.o	\
 	module_compute_geop.o           \
-	module_soil_pre.o
+	module_soil_pre.o \
+        cpdet_mod.o
 
 OBJS    = 		\
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/cpdet_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/cpdet_mod.F	(revision 1724)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/cpdet_mod.F	(revision 1724)
@@ -0,0 +1,114 @@
+module cpdet_mod
+
+implicit none
+
+! ADAPTATION OF GCM TO CP(T)
+!======================================================================
+! From S. Lebonnois in LMD Venus GCM
+!
+! Cp must be computed using cpdet(t) to be valid
+!
+! The Exner function is still pk = (play/pref)**RKAPPA
+! (RCPD=cpp, RKAPPA=kappa)
+!
+! One goes from T to teta (potential temperature) using t2tpot(t,teta,pk)
+! One goes from teta to T using tpot2t(teta,t,pk)
+!
+!======================================================================
+
+contains
+
+      FUNCTION cpdet(t)
+
+!      USE control_mod, ONLY: planet_type 
+!      USE comconst_mod, ONLY: cpp,t0_venus,nu_venus
+      USE module_configure 
+      USE module_model_constants
+      IMPLICIT none
+
+! for cpp, nu_venus and t0_venus:
+
+      real,intent(in) :: t
+      real cpdet
+
+      if (planet.eq."venus") then
+          cpdet = cp*(t/TT00)**nu
+      else
+          cpdet = cp
+      endif
+
+      return
+      end function cpdet
+      
+!======================================================================
+!======================================================================
+
+      SUBROUTINE t2tpot(npoints, yt, yteta, ypk)
+!======================================================================
+! Arguments:
+!
+! yt   --------input-R- Temperature
+! yteta-------output-R- Temperature potentielle
+! ypk  --------input-R- Fonction d'Exner: (pplay/pref)**RKAPPA
+!
+!======================================================================
+
+!      USE control_mod, ONLY: planet_type 
+!      USE comconst_mod, ONLY: cpp,t0_venus,nu_venus
+      USE module_configure
+      USE module_model_constants
+
+
+      IMPLICIT NONE
+
+      integer,intent(in) :: npoints
+      REAL,intent(in) :: yt(npoints), ypk(npoints)
+      REAL,intent(out) :: yteta(npoints)
+      if (planet.eq."venus") then
+          yteta = yt**nu                                          &
+     &            - nu * TT00**nu * log(ypk)
+          yteta = yteta**(1./nu)
+      else
+          yteta = yt * 1./ypk
+      endif
+
+      return
+      end subroutine t2tpot
+
+!======================================================================
+!======================================================================
+
+      SUBROUTINE tpot2t(npoints,yteta, yt, ypk)
+!======================================================================
+! Arguments:
+!
+! yteta--------input-R- Temperature potentielle
+! yt   -------output-R- Temperature
+! ypk  --------input-R- Fonction d'Exner: (pplay/pref)**RKAPPA
+!
+!======================================================================
+
+!      USE control_mod, ONLY: planet_type 
+!      USE comconst_mod, ONLY: cpp,nu_venus,t0_venus
+      USE module_configure
+      USE module_model_constants
+
+
+      IMPLICIT NONE
+
+      integer,intent(in) :: npoints
+      REAL,intent(in) :: yteta(npoints), ypk(npoints)
+      REAL,intent(out) :: yt(npoints)
+      print*,planet
+      if (planet.eq."venus") then
+         yt = yteta**nu                                           &
+     &       + nu * TT00**nu * log(ypk)
+         yt = yt**(1./nu)
+         print*,yt
+      else
+          yt = yteta * ypk
+      endif
+      print*,yt 
+      return
+      end subroutine tpot2t
+end module cpdet_mod
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/module_model_constants.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/module_model_constants.F	(revision 1662)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/share/module_model_constants.F	(revision 1724)
@@ -8,5 +8,5 @@
 
    !  A really small number.
-
+   character(len=15) :: planet
    REAL    , PARAMETER :: epsilon         = 1.E-15
 
@@ -183,10 +183,10 @@
     REAL  :: z_scale        ! scale height 
 
+    REAL :: TT00
+    REAL :: nu
  CONTAINS
   SUBROUTINE init_planet_constants
     IMPLICIT NONE
-    character(len=15) :: planet
     Call initial_config
-    planet=model_config_rec%planet 
     !write(*,*) "unknown planet type", planet
     !stop
@@ -239,4 +239,6 @@
      wvolcapa      = 1.e6       ! volumetric capacity of soil (new soil model)
 #endif
+     TT00=0.
+     nu=0.
 !#endif
     ELSE if ( planet == "venus") then 
@@ -255,4 +257,6 @@
      womeg        = 0.2992549E-06
      wdaysec      = 0.1008707E08
+     TT00=460.
+     nu=0.35
     ELSE if ( planet == "prescribed") then
      open(17,file='planet_constant',form='formatted',status='old')
@@ -268,4 +272,6 @@
      p1000mb=p0
      reradius=1./rad
+     TT00=0.
+     nu=0.
     Else 
      write(*,*) "unknown planet type:", planet
@@ -295,4 +301,6 @@
     write(*,*) "t0 = ", t0
     write(*,*) "p0 = ", p0
+    write(*,*) "T0 = ", TT00
+    write(*,*) "nu = ", nu
   END SUBROUTINE init_planet_constants
  END MODULE module_model_constants
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.:
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.:	(revision 1724)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.:	(revision 1724)
@@ -0,0 +1,1 @@
+link /u/mlefevre/MODELES/LMDZ.VENUS/Tools/
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.makelmdz
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.makelmdz	(revision 1724)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/.makelmdz	(revision 1724)
@@ -0,0 +1,1 @@
+grid misc phy_common phyvenus phyvenus/dyn1d
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch	(revision 1724)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch	(revision 1724)
@@ -0,0 +1,1 @@
+link /planeto/mlefevre/MODELES/LMDZ.COMMON/arch/
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch.fcm
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch.fcm	(revision 1724)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/venus_lmd_new/arch.fcm	(revision 1724)
@@ -0,0 +1,1 @@
+link arch/arch-linux-ifort_meso.fcm
